% analizza risultati in funzione di ordine e n-Henkel
close all
clear all
clc

load('Res_order_noise!.mat');
load('target_frequency.mat');
load('target_shape.mat');

M_df=[];
M_dMAC=[];

list_max_order=fieldnames(Results);
numb_order=length(list_max_order);
for s=1:numb_order
        name_max_order=char(list_max_order(s,:));
        list_noise=fieldnames(Results.(name_max_order));
        numb_noise=length(list_noise);
        a=isstrprop(name_max_order,'digit');
        order=(str2num(name_max_order(a)));
        for ss=1:numb_noise
            name_noise=char(list_noise(ss,:));
            list_nmode=fieldnames(Results.(name_max_order).(name_noise));
            numb_nmode=length(list_nmode);
            aa=isstrprop(name_noise,'digit');
            noise=(str2num(name_noise(aa)));
            for sss=1:numb_nmode
                name_nmode=char(list_nmode(sss,:));
                f=Results.(name_max_order).(name_noise).(name_nmode).f;
                df(sss,:)=(abs(f-target_frequency)');
                V=Results.(name_max_order).(name_noise).(name_nmode).V;
                dMAC(sss,:)=(1-(V'*target_shape).^2./(norm(V)*vecnorm(target_shape)).^2);
            end
            %identification mode fro df
            pos=df==min(df,[],1);
            dfmin=df.*pos;
            dfmin(pos==0)=NaN;
            dfmin=min(dfmin,[],2);
            p_df=dfmin<0.1;
            n_df=sum(p_df);
            precision_df=n_df/numb_nmode;
            recall_df=n_df/9;
            K_df=[order noise precision_df recall_df];
            M_df=[M_df K_df'];
            %identification mode for MAC
            clear pos
            pos=dMAC==min(dMAC,[],1);
            dMACmin=dMAC.*pos;
            dMACmin(pos==0)=NaN;
            dMACmin=min(dMACmin,[],2);
            p_dMAC=dMACmin<0.1;
            n_dMAC=sum(p_dMAC);
            precision_dMAC=n_dMAC/numb_nmode;
            recall_dMAC=n_dMAC/9;
            K_dMAC=[order noise precision_dMAC recall_dMAC];
            M_dMAC=[M_dMAC K_dMAC'];
        end
end


ordersN=unique(M_df(1,:));
noiseN=unique(M_df(2,:));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%df
for i=1:size(M_df,2)
    pos1=M_df(1,i)==ordersN(:);
    pos2=M_df(2,i)==noiseN(:);
    C_r_df(pos1,pos2)=M_df(4,i);
    C_p_df(pos1,pos2)=M_df(3,i);
end
[X,Y]=meshgrid(ordersN,noiseN);

%recall

figure(1)
s=pcolor(X,Y,C_r_df');
s.FaceColor='interp'
title('df recall')
xlabel('max order')
ylabel('noise level')
colorbar
% hold on
% Z=2*ordersN/9
% plot(ordersN,Z,'Color','y','Linewidth',2)
% hold off

%precision

figure(2)
s=pcolor(X,Y,C_p_df');
s.FaceColor='interp'
title('df precision')
xlabel('max order')
ylabel('noise level')
colorbar

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%dMAC
for i=1:size(M_dMAC,2)
    pos1=M_dMAC(1,i)==ordersN(:);
    pos2=M_dMAC(2,i)==noiseN(:);
    C_r_dMAC(pos1,pos2)=M_dMAC(4,i);
    C_p_dMAC(pos1,pos2)=M_dMAC(3,i);
end
[X,Y]=meshgrid(ordersN,noiseN);

%recall

figure(3)
t=pcolor(X,Y,C_r_dMAC');
t.FaceColor='interp'
title('dMAC recall')
xlabel('max order')
ylabel('noise level')
colorbar

%precision

figure(4)
t=pcolor(X,Y,C_p_dMAC');
t.FaceColor='interp'
title('dMAC precision')
xlabel('max order')
ylabel('noise level')
colorbar



