clear all
clc
close all
format short
%Define the stiffness matrix:
Kxx=[1.89,-0.863,-0.0567;-.863,1.36,-.574;-.0576,-.574,.441]*1e9;
Kyy=[1.93,-.778,0.00224;-.778,1.33,-.52;.00224,-.52,.511]*1e9;
Kxg=[-13.4,6.09,-.406;6.09,-9.56,4.05;-.406,4.05,-3.11]*1e9;
Kyg=[7.4,-3.11,0.0293;-3.11,5.25,-2.04;0.0293,-2.04,2.03]*1e9;
Kgg=[21.1,-9.64,.470;-9.64,15.5,-6.37;.470,-6.37,5.4]*1e10;
K00=zeros(size(Kxx));
K=[Kxx,K00,Kxg;K00,Kyy,Kyg;Kxg,Kyg,Kgg];

%Define the mass matrix:
Mxx=diag([199926,173425,200717]);
Myy=Mxx;
Mxg=diag([-1262530,-1095179,-1267529]);
Myg=diag([762350,659897,772463]);
Mgg=diag([19742644,16901864,20166960]);
M=[Mxx,K00,Mxg;K00,Myy,Myg;Mxg,Myg,Mgg];


%%%%%%%%%%%%%EARTHQUAKE%%%%%%%%%%%
% A=load('Earthquake records\elcentro.txt');
%Ambient noise A=Amplitude*randn()
% At=A(:,2);
% t=A(:,1);
ts=1/200;fs=1/ts;
Tmax=180;
t=linspace(0,Tmax,fs*Tmax+1)';
At=.005*randn(length(t),1);
% ts=t(2)-t(1);

% Tmax=ts*(length(At)-1);

% DATI                                                                                      
% smz=0.05;
% xgdl=linspace(0.1,0.5,size(K,2));
% smz=smz*xgdl;
smz=[0.002 0.006 0.013 0.035 0.008 0.015 0.007 0.029 0.02];

%ANALISI TIME - HISTORY:
[F,E]=eig(K,M);

%Normalise eigenmodes:
for ii=1:9
    U(:,ii)=F(:,ii)./sqrt(F(:,ii)'*M*F(:,ii));
end

wn=sqrt(E)*ones(length(E),1);
fr_analytic=wn/(2*pi);
T=1./fr_analytic;
% track=ones(9,1);
track=[2;0.5;0.5;-1.5;1;1;-0.03;-0.03;0.01];
track=track/norm(track);
Gk=-U'*M*track;
h=zeros(length(t),3);
for i=1:min(size(U));
    wd(i)=wn(i)*sqrt(1-smz(i)^2);
    h(:,i)=(1/wd(i))*exp(-smz(i)*wn(i)*t).*sin(wd(i)*t);
    p(:,i)=ts*conv((Gk(i)*At),h(:,i));
end

time=[0:ts:(length(p)-1)*ts];

% for i=1:length(F);
% figure
% plot(time,p(:,i));
% grid on; xlabel('Tempo [s]');
% ylabel('Coordinate modali p');
% end

%Spostamenti:
u=U*p';

for i=1:length(F);
figure
plot(time,u(i,:));
grid on; xlabel('Tempo [s]');
ylabel('Spostamenti u [m]');
end

%Acceleration measured in origin:
a1=gradient(gradient(u(1:3,:),ts),ts);
a2=gradient(gradient(u(4:6,:),ts),ts);

%Determine the acceleration on the last frame:
a3=gradient(gradient(u(1:3,:)-u(7:9,:)*10,ts),ts);

figure,plot(time,a2)


a=[a1;a2;a3];
signal=a(:,1:length(a)/2+1)';


%ADD 5% LEVEL NOISE TO THE SIGNAL
perc=2;

for ii=1:size(signal,2)
    signal(:,ii)=signal(:,ii)+perc*std(signal(:,ii))*randn(size(signal(:,ii)));
end

%target shape


target_frequency=sort(fr_analytic)
target_shape=[]
for i=1:length(target_frequency)
    pos= target_frequency(i)==fr_analytic
    target_shape=[target_shape F(:,pos==1)]
end

for jj=1:length(F)
g(jj)=(U(:,jj)'*M*track);
end

mtot=track'*M*track;

mm=(g.^2)/mtot;





% % EXERCISE1
% %IDENTIFICATION OF NUMERICAL DATA (FREE DECAY) 
% % clear all,close all,clc
% Ts=ts;
% 
% figure,
% plot(a');
% 
% n=10; r=10; s=250;
% [w,z,mod,ph1]=ERA(signal,Ts,r,s,n);
% 
% %Fourier transform of the signal:
% Xf=fft(signal(:,1));
% f=[0:1/(Ts*(length(signal)-1)):1/(2*Ts)]';
% figure,plot(f,abs(Xf(round((1:length(Xf)/2+1)))));
% figure,plot([0:Ts:(length(signal)-1)*Ts],signal);
% 
% %Plot modal shapes:
% % modshape=zeros(length(mod),min(size(mod))+1);
% modshape=mod'.*sign(cos(ph1))'; 
% f=w./(2*pi);
% H=[0;3;6;9];

%  for i=2:length(w)
%      if f(i-1)==f(i)
%      figure,
%      hold on,plot([0,modshape(i,1:3)],H,[0,modshape(i,4:6)],H,[0,modshape(i,7:9)],H),legend('u','v','spost3')
%      gtitle=['Frequency ',num2str(f(i)),' Hz'];grid on;
%      title(gtitle);
%      end
%  end
%  
%  for ii=1:9
%       figure,
%       hold on
%       plot([0;F(1:3,ii)],H,'--',[0;F(4:6,ii)],H,'--',[0;F(7:9,ii)],H,'--'),legend('u','v','gamma')
%       gtitle=['Frequency ',num2str(fr_analytic(ii)),' Hz'];grid on;
%       title(gtitle);
%  end
%  
 %%%%%


% %% EXERCISE 2
% %IDENTIFICATION OF NUMERICAL DATA (AMBIENT TEST)
% %DATA:
% clear all,close all,clc
% load signal1
% signal=a(:,1:50000)';
% 
% tau=5000;a1=0;a2=4;
% RDsignal=RDautocross(signal,tau,a1,a2);
% 
% Ts=1/256;n=10;r=10;s=250;
% t=[0:Ts:(length(RDsignal)-1)*Ts];
% [wrd,zrd,modrd,ph1rd]=ERA(RDsignal,Ts,r,s,n);
% 
% figure,plot(t,RDsignal(:,1)),xlabel('Time [s]'),ylabel('Acceleration [m/s^2]'),title('Free Decay Signal')
% grid on
% 
% %Plot modal shapes:
% modshape=zeros(length(modrd),min(size(modrd))+1);
% modshape(:,2:min(size(modrd))+1)=modrd'.*sign(cos(ph1rd))'; 
% f=wrd./(2*pi);
%  for i=2:length(w)
%      if f(i-1)==f(i)
%      figure,plot(modshape(i,:),0:1:min(size(mod))),
%      gtitle=['Frequency ',num2str(f(i)),' Hz'];grid on;
%      title(gtitle);
%      end
%  end
% %% EXERCISE 3a
% %IDENTIFICATION OF NUMERICAL DATA (FREE DECAY - 3D FRAME):
% clear all,close all,clc
% 
% load signal2
% signal=[aL1(:,(length(aL1)/2):length(aL1))',aL2(:,(length(aL1)/2):length(aL1))',aJ1(:,(length(aL1)/2):length(aL1))'];
% Ts=1/256;
% 
% %ERA identification:
% n=10; r=10; s=250;
% [w,z,mod,ph1]=ERA(signal,Ts,r,s,n);
% 
% %Fourier transform of one of the signals:
% Xf=fft(signal(:,1));
% f=[0:1/(Ts*(length(signal)-1)):1/(2*Ts)];
% figure,plot(f,abs(Xf(round((1:length(Xf)/2)))));
% figure,plot([0:Ts:(length(signal)-1)*Ts],signal);
% 
% %Plot modal shapes (this is not a correct rappresentation of modal shapes, 
% %find something different for 3D frames):
% modshape=zeros(length(mod),min(size(mod))+1);
% modshape(:,2:min(size(mod))+1)=mod'.*sign(cos(ph1))'; 
% f=w./(2*pi);
%  for i=2:length(w)
%      if f(i-1)==f(i)
%      figure,plot(modshape(i,:),0:1:min(size(mod))),
%      gtitle=['Frequency ',num2str(f(i)),' Hz'];grid on;
%      title(gtitle);
%      end
%  end
% %% EXERCISE 3b
% %IDENTIFICATION OF NUMERICAL DATA (NOISE - 3D FRAME)
% %DATA:
% clear all,close all,clc
% load signal2
% signal=[aL1(:,1:(length(aL1)/2))',aL2(:,1:(length(aL1)/2))',aJ1(:,1:(length(aL1)/2))'];
% Ts=1/256;
% 
% tau=1000;a1=0;a2=4;
% RDsignal=RDautocross(signal,tau,a1,a2);
% 
% Ts=1/256;n=10;r=10;s=250;
% t=[0:Ts:(length(signal)-1)*Ts];
% [wrd,zrd,modrd,ph1rd]=ERA(RDsignal,Ts,r,s,n);
% 
% %Fourier transform of the signal:
% Xf=fft(signal(:,3));
% f=[0:1/(Ts*(length(signal)-1)):(1/(2*Ts))];
% figure,plot(f,abs(Xf(1:length(f))));
% %figure,plot([0:Ts:(length(signal)-1)*Ts],signal);
% 
% rdtime=[0:Ts:(length(RDsignal)-1)*Ts];
%  figure,plot(rdtime,RDsignal(:,1)),xlabel('Time [s]'),ylabel('Acceleration [m/s^2]'),title('Free Decay Signal generated with RD function')
%  grid on
%  
% %Plot modal shapes (this is not a correct rappresentation)
% modshape=zeros(length(modrd),min(size(modrd))+1);
% modshape(:,2:min(size(modrd))+1)=modrd'.*sign(cos(ph1rd))'; 
% f=wrd./(2*pi);
%  for i=2:length(w)
%      if f(i-1)==f(i)
%      figure,plot(modshape(i,:),0:1:min(size(mod))),
%      gtitle=['Frequency ',num2str(f(i)),' Hz'];grid on;
%      title(gtitle);
%      end
%  end
% 
% %% EXERCISE 4
% %IDENTIFY EXPERIMENTAL DATA:
% %SHOCK HAMMER TEST
% clear all,close all,clc;
% 
% % fid=fopen('SHT.txt');
% % A=textscan(fid,'%f %f %f %f %f %f %f','HeaderLines',3);
% % t=A{1};Ts=t(2);
% % X=[A{2:7}];
% % fclose(fid);
% 
% load SHT sig ts
% 
% n=10; r=10; s=500;
% [w,z,mod,ph1]=ERA(sig,ts,r,s,n);
% 
% t=[0:ts:ts*(length(sig)-1)];
% figure,plot(t,sig(:,1)),xlabel('Time [s]'),ylabel('Acceleration [m/s^2]'),title('Free Decay signal')
% grid on
% %% EXERCISE 5
% %USE THE PREFILTERED SIGNALS:
% clear all,clc
% load SHT filteredsig
% 
% %Subsampling 8, prefiltered at 50 Hz.
% ts=1/100;n=10; r=10; s=500;
% 
% [wf,zf,modf,ph1f]=ERA(filteredsig,ts,r,s,n);
% 
% t=[0:ts:ts*(length(filteredsig)-1)];
% figure,plot(t(1:length(filteredsig)),filteredsig(:,1)),xlabel('Time [s]'),ylabel('Acceleration [m/s^2]'),title('Shock Hammer Test')
% grid 
% 
% 
% %% EXERCISE 6
% %USE OF RD FUNCTIONS TO IDENTIFY AVT EXPERIMENTAL DATA:
% clear all,clc,close all
% load AVT;
% 
% tau=1000;a1=0;a2=10;%a2=2*mean(std(AVT1filtered));
% AVTRD=RDautocross(filteredsig,tau,a1,a2);
% 
% figure,plot(AVTRD(:,1)),xlabel('Time [s]'),ylabel('Acceleration [m/s^2]'),title('Free Decay Signal')
% grid on
% 
% %Subsampling 8, prefiltered at 50 Hz.
% Ts=1/100;n=10;r=10;s=250;
% 
% [wrd,zrd,modrd,ph1rd]=ERA(AVTRD,Ts,r,s,n);





