% close all
% clear all
% clc

% 
% list=dir;

%WHITE NOISE
% for ii=3:21
%     AA(:,ii-2)=load(list(ii).name);
%     BB(:,ii-2)=AA(ii-2).data;
% end
% 

% %DATA TO EXTRACT


clear all
close all
clc

Results=struct

for levelnoise=1:10

    switch levelnoise
        case{1}
            name='signal_noise_1%';
        case{2}
            name='signal_noise_5%';
        case{3}
            name='signal_noise_10%';
        case{4}
            name='signal_noise_20%';
        case{5}
            name='signal_noise_30%';
        case{6}
            name='signal_noise_50%';
        case{7}
            name='signal_noise_75%';
        case{8}
            name='signal_noise_100%';
        case{9}
            name='signal_noise_150%';
        case{10}
            name='signal_noise_200%';
    end


load(name);


% Barbara=struct
% Barbara.(name).f=signal

data=signal;

[m,n]=size(data);

nchan=n;

signal=data; clear data;

%Signal subsampling/decimation
fs=200; 
n_dec=1;
for jj=1:nchan
    signalD(:,jj)=decimate(signal(:,jj),n_dec);
end

fs=fs/n_dec;
clear signal
signal=signalD; clear signalD;

%Signal truncation (first 100 seconds).
% signal=signal(1:(100*fs),:);



% sens = [1.098 1.116 1.111 1.091 1.071 1.100 1.113 1.087];
% v_chan= [ 1 1 -1 -1 -1 1 -1 -1];

% for ii=1:nchan
%     signal(:,ii)=sens(ii)*signal(:,ii);
% end

chid_x=[1:2:17];
chid_y=[2:2:18];
chid_z=19;

dt=1/fs;
t=[0:dt:dt*(length(signal)-1)]';

% Data cleansing
% Mean and trend removal with polynomial
% polyfit(x,y,n) cerca un polinomio di grado n che fitti y(x)
% nel nostro caso polyfit  una retta (trend + media)
% polyval(p,x) trova i valori del polinomio p[an an-1 ...] di grado n nei punti x
% andando a togliere polyval dal nostro campione stiamo togliendo trend e media:
for ii=1:nchan
    p=polyfit(t,signal(:,ii),1);
    pf = polyval(p,t);
    signal(:,ii)=signal(:,ii)-pf;
end

% % applicazione del filtro perch ho una deriva a frequenza molto bassa
% filter_order = 3;
% filter_cutoff=[0.0000001 40];
% [filt_num,filt_den] = butter(filter_order,(filter_cutoff)/(fs/2));
% for ii=1:nchan
%     signal(:,ii) = filter(filt_num,filt_den,signal(:,ii));
% end

% %Rimozione primi 10 s, distorti:
% signal=signal(fs*10:end,:);


t=0:dt:(length(signal)-1)*dt;
T=(length(signal)-1)*dt;
f=[-fs/2:1/T:fs/2];



% XX=gpuArray(signal(:,1:end));
FT=fft(signal(:,1:end));
% clear XX

figure,
subplot(2,1,1),plot(t,signal(:,1:size(signal,2)))
xlabel('Time [s]'),ylabel('Acceleration [g]')
subplot(2,1,2),plot(f,20*log10(abs(fftshift(FT))))
xlabel('Frequency[Hz]'), ylabel('|fft|'),xlim([0,200])
leg_lab={'X1';'X2';'X3';'Y1';'Y2';'Y3';'R1';'R2';'R3'};
legend(leg_lab)



NFFT=4096;              %   n punti della trasformata di fourier (potenze di 2)
% filter_cutoff=[.1 200];  %   estremi del filtro
% pn_r=4;                 %	numero di righe nel subplot
% pn_c=5;                 %	numero si colonne nel subplot
% dec=1;                  %   fattore di decimazione
% %
% [PSDdata,fr_axis,signal_filt]=plotpsd(signal,fs,NFFT,filter_cutoff,pn_r,pn_c,dec);
for ii=1:nchan
    [PSDdata(:,ii),f1] = pwelch(signal(:,ii),NFFT/2,NFFT/4,NFFT,fs);
end
% 
% figure,plot(f1,PSDdata)
% xlabel('Frequency [Hz]')
% legend('01X','01Y','02X','02Y','03X','03Y','04X','04Y','05X','05Y','06X','06Y','07X','07Y','08X','08Y','09X','09Y','09Z')



% STABILIZATION DIAGRAM
% stabilisation_diagram(sig,n_min,n_max,fs,f_up,NFFT,weight,nch,mode)
%  INPUT:
%   sig     =   signal matrix;
%   n_min   =   minimum order;
%   n_max   =   maximum order;
%   fs      =   sampling frequency;
%   f_up    =   maximum frequency to be displayed;
%   NFFT    =   number of samples of the welch transform
%   weight  =   magnitude of the background PSD welch;
%   nch     =   number of channel to be plotted
%   mode    =   frequencies of the identified poles


%FINITE ELEMENT FREQUENCIES
%Mode X:
mode=[];
f_FEM=[];

for jj=[60:4:120]%40%

%STABILIZATION PARAMETERS
n_min=10;
n_max=jj;
n_step=2;
nn=n_min:n_step:n_max;%Number of modes to extract vector

%Stabilisation diagram criteria
stab.d_min       =  0; %minimo damping
stab.d_max       =  0.1; %massimo damping
stab.dfr        =  0.005;
stab.dz        =  0.1;
stab.dMAC=0.95;
stab.NumMAC         =  5; %Number of stable orders in terms of MAC
stab.epsilon  = 0.05;

stab.f_min       =  0;  
stab.f_max       =  110;

%PSD TO PLOT
psds.chan=[5,6,7];
psds.data=PSDdata;
psds.fr_axis=f1;

for ak=6%20:6:170
    max_order=jj;
    %Henkel_ak=ak;
    Henkel_n=round(ak*n_max/nchan);




rerun=1;
for kk=1
    
    tempname=[name(1:end-4),'_',num2str(kk),'_ID.mat'];
%     y=signal(1+(kk-1)*100*fs:kk*(100*fs),:);
    y=signal;
    
    if rerun==1
        %STABILISATION DIAGRAM
        count=1;
        n_block=round(Henkel_n);%n_block Hankel matrix
        [sysID]=sto_stab_mpd(y,n_block,fs,nn);
        count=count+1;

    else
        load(['ID_RESULTS' filesep tempname])

    end    
end



% stab_modes=full_id(1059:end,1:21);
% [~,ind]=sort(stab_modes(:,1));
% stab_modes=stab_modes(ind,:)';

% Henkel_n/name per analisi con variabile Henkel_n/ noise level
[Results]=stab_VEZIO_G(sysID,name,max_order,Results);

end
end














% % %%%%%%%%%%CLUSTERING%%%%%%%%%%%%%%%%%
% % 
% % indices=find(clust(:,1)<4.5 & clust(:,1)>0.5 & clust(:,2)<0.025);
% % data.X=clust(indices,:);
% % 
% % %parameters
% % param.c=7;
% % param.m=2;
% % param.e=1e-6;
% % param.ro=ones(1,param.c);
% % param.val=3;
% % %normalization
% % % data=clust_normalize(data,'range');
% % %clustering
% % result = FCMclust(data,param);
% % 
% % h=figure('Position',[300,300,700,500]);
% % % plot(data.X(:,1),data.X(:,2),'b.',result.cluster.v(:,1),result.cluster.v(:,2),'ro');
% % % hold on
% % % ylim([0 0.1])
% % % xlim
% % 
% % font=14;
% % idx = findClosestCentroids(data.X, result.cluster.v);
% % hold on
% % plotProgresskMeans(data.X, result.cluster.v, result.cluster.v, idx, param.c);
% % grid on
% % xlim([0,4]),ylim([0,0.05])
% % xlabel('Frequency [Hz]','Fontsize',font),ylabel('Damping','Fontsize',font);
% % set(gca,'Fontsize',font,'XTick',0:0.5:5,'GridLineStyle',':')
% % 
% % saveas(h,[name(1:end-4),'_clust.emf'])
% % saveas(h,[name(1:end-4),'_clust.bmp'])
% % 
% % 
% % full_id=full_id(indices,1:size(signal,2)+2);
% % 
% % for ii=1:6;
% %     ID_RES(ii,:)=mean(full_id(idx==ii,:));
% % end
% % 
% % [~,IndS]=sort(ID_RES(:,1));
% % ID_RES=ID_RES(IndS,:)';
% % 
% % 
% % % %draw contour-map
% % % new.X=data.X;
% % % eval=clusteval(new,result,param);
% % % %validation
% % % result = validity(result,data,param);
% % % result.validity
end