function [results]=stab_VEZIO_F(sysID)





n_fig=0;
sysID1 = sysID;

%controlla damping
for ii=1:size(sysID,2)
    pos= sysID1(ii).ident(2,:)>0.2;
    sysID1(ii).ident(:,pos)=[];
    sysID1(ii).mpd(:,pos)=[];
end

for ii=1:size(sysID,2)
    pos= sysID1(ii).ident(2,:)<0;
    sysID1(ii).ident(:,pos)=[];
    sysID1(ii).mpd(:,pos)=[];
end

%calcolare e inserie autovalori in sysID
for ii=1:size(sysID1,2);
    sysID1(ii).eig=-2*pi*sysID1(ii).ident(1,:).*sysID1(ii).ident(2,:)+2i*pi*sysID1(ii).ident(1,:).*sqrt(1-sysID1(ii).ident(2,:).^2)
end

clear pos ii

%crea parametri di comprazione
%nota: non sono convinto che cos facendo j viene comparato allo stesso k
%per df ddr e dMAC.
sysID2=sysID1;
for i=1:(size(sysID1,2)-1);
    df=[];
    dl=[];
    ddr=[];
    dMAC=[];
    a=[];
    for j=1:size(sysID1(i).ident,2);
        for k=1:size(sysID1(i+1).ident,2);
        df(j,k)=abs((sysID1(i).ident(1,j)-sysID1(i+1).ident(1,k))/...
            max(sysID1(i).ident(1,j),sysID1(i+1).ident(1,k)));
        dl(j,k)=abs(sysID1(i).eig(1,j)-sysID1(i+1).eig(1,k))/...
            max(abs(sysID1(i).eig(1,j)),abs(sysID1(i+1).eig(1,k)));
        ddr(j,k)=abs((sysID1(i).ident(2,j)-sysID1(i+1).ident(2,k))/...
            max(sysID1(i).ident(2,j),sysID1(i+1).ident(2,k)));
        dMAC(j,k)=(abs(sysID1(i).ident(3:end,j)'*sysID1(i+1).ident(3:end,k)))^2/...
            ((norm(sysID1(i).ident(3:end,j))^2*norm(sysID1(i+1).ident(3:end,k))^2));
        dMPD=abs((sysID1(i).mpd(j)-sysID1(i+1).mpd(k))/...
            max(sysID1(i).mpd(j),sysID1(i+1).mpd(k)));
        end
        a=df+ddr+dl+1-dMAC;%
        pos= a(j,:)==min(a(j,:));
        sysID2(i).dl(j)=dl(j,pos);
        sysID2(i).df(j)=(df(j,pos));        
        sysID2(i).ddr(j)=(ddr(j,pos));
        sysID2(i).dMAC(j)=(1-dMAC(j,pos));
        sysID2(i).dMPD(j)= dMPD;            
    end
%             sysID2(i).mpd=1-sysID1(i).mpd/(pi()/2);
end
clear ddr df dMAC ii i j k pos epsMPC tetaMPC a

omdl=[]; osdl=[];
omdf=[]; osdf=[];
omddr=[]; osddr=[];
omdMAC=[]; osdMAC=[];
omdMPD=[]; osdMPD=[];
for i=1:(size(sysID2,2)-1)
    omdl=[omdl mean(sysID2(i).dl)]; osdl=[osdl std(sysID2(i).dl)];
    omdf=[omdf mean(sysID2(i).df)]; osdf=[osdf std(sysID2(i).df)];
    omddr=[omddr mean(sysID2(i).ddr)]; osddr=[osddr std(sysID2(i).ddr)];
    omdMAC=[omdMAC mean(sysID2(i).dMAC)]; osdMAC=[osdMAC std(sysID2(i).dMAC)];
    omdMPD=[omdMPD mean(sysID2(i).mpd)]; osdMPD=[osdMPD std(sysID2(i).mpd)];
end

%per ogni ordine esegui la media dei vettori 'soft criteria' e plotta tali
%medie in funzione dell'ordine

n_fig=n_fig+1;

figure(n_fig)
x=[sysID(1:end-1).order];
plot(x,omdl)
hold on
plot(x,omdf)
plot(x,omddr)
plot(x,omdMAC)
plot(x,omdMPD)
legend('omdl','omdf','omddr','omdMAC','omdMPD')
title('mean soft criteria per order')
hold off


%preparazione dati per clustering 2-means
%crea matrice di confronto X

sysIDcell=struct2cell(sysID2(:));
MPD=cell2mat(sysIDcell(3,1:end-1))
dl=cell2mat(sysIDcell(5,:));
df=cell2mat(sysIDcell(6,:));
ddr=cell2mat(sysIDcell(7,:));
dMAC=cell2mat(sysIDcell(8,:));
dMPD=cell2mat(sysIDcell(9,:));
fdrV=cell2mat(sysIDcell(1,1:(end-1)));

order=[];
for ii=1:size(sysIDcell,2)-1
    order=[order repmat(sysIDcell{2,ii},1,size(sysIDcell{1,ii},2))];
end

f=fdrV(1,:);
dr=fdrV(2,:);
V=fdrV(3:end,:);


[XA,LA]=boxcox(df'); XAm=mean(XA); XAs=std(XA); XAn=(XA-XAm)/XAs;
[XB,LB]=boxcox(ddr'); XBm=mean(XB); XBs=std(XB); XBn=(XB-XBm)/XBs;
[XC,LC]=boxcox(dMAC'); XCm=mean(XC); XCs=std(XC); XCn=(XC-XCm)/XCs;
[XD,LD]=boxcox(dl'); XDm=mean(XD); XDs=std(XD); XDn=(XD-XDm)/XDs;
[XE,LE]=boxcox(MPD'+0.1); XEm=mean(XE); XEs=std(XE); XEn=(XE-XEm)/XEs;
XFn=[XAn XBn XCn XDn XEn];
XGn=[XAn XBn XCn XDn];

%test di verifica normalit

[norm_test.df norm_test(2).df]=kstest(XAn);
[norm_test.ddr norm_test(2).ddr]=kstest(XBn);
[norm_test.dMAC norm_test(2).dMAC]=kstest(XCn);
[norm_test.dl norm_test(2).dl]=kstest(XDn);
[norm_test.MPD norm_test(2).MPD]=kstest(XEn);

%transforming the mean of the soft criteria per each order with BOX-COX and
%normalization

BComdf=trasf_BC(omdf,LA); nBComdf=(BComdf-XAm)/XAs;
BComddr=trasf_BC(omddr,LB); nBComddr=(BComddr-XBm)/XBs;
BComdMAC=trasf_BC(omdMAC,LC); nBComdMAC=(BComdMAC-XCm)/XCs;
BComdl=trasf_BC(omdl,LD); nBComdl=(BComdl-XDm)/XDs;
BComdMPD=trasf_BC(omdMPD,LE); nBComdMPD=(BComdMPD-XEm)/XEs;

n_fig=n_fig+1;
figure(n_fig)
x=[sysID(1:end-1).order];
plot(x,nBComdl)
hold on
plot(x,nBComdf)
plot(x,nBComddr)
plot(x,nBComdMAC)
plot(x,nBComdMPD)
legend('omdl','omdf','omddr','omdMAC','omdMPD')
title('mean soft criteria (B-C and normalization) per order')
hold off

%applica 2-means alla matrice confronto e separa i possibili modi fisici 
%(cluster1) da quelli certamente spuri (cluster2); plot results.

[idxnA,CA] = kmeans(XAn,2,'Start',[min(XAn); max(XAn)]);
[idxnB,CB] = kmeans(XBn,2,'Start',[min(XBn); max(XBn)]);
[idxnC,CC] = kmeans(XCn,2,'Start',[min(XCn); max(XCn)]);
[idxnD,CD] = kmeans(XDn,2,'Start',[min(XDn); max(XDn)]);
[idxnE,CE] = kmeans(XEn,2,'Start',[min(XEn); max(XEn)]);
[idxnF,CF] = kmeans(XFn,2,'Start',[min(XAn) min(XBn) min(XCn) min(XDn) min(XEn); max(XAn) max(XBn) max(XCn) max(XDn) max(XEn)]);
[idxnG,CG] = kmeans(XGn,2,'Start',[min(XAn) min(XBn) min(XCn) min(XDn); max(XAn) max(XBn) max(XCn) max(XDn)]);

pos=idxnE(:)==2; %idxnE(:)==2%|idxnA(:)==2|idxnB(:)==2|idxnC(:)==2|idxnD(:)==2;%idxnE(:)==2;
% 
% max_nBCdf=min(XAn(pos==1)); max_BCdf=max_nBCdf*XAs+XAm; max_df=inv_BC(max_BCdf,LA);
% max_nBCddr=min(XBn(pos==1)); max_BCddr=max_nBCddr*XBs+XBm; max_ddr=inv_BC(max_BCddr,LB);
% max_nBCdMAC=min(XCn(pos==1)); max_BCdMAC=max_nBCdMAC*XCs+XCm; max_dMAC=inv_BC(max_BCdMAC,LC);
% max_nBCdl=min(XDn(pos==1)); max_BCdl=max_nBCdl*XDs+XDm; max_dl=inv_BC(max_BCdl,LD);
% figure(97)
% x=[sysID(1:end-1).order];
% plot(x,nBComdf)
% hold on

hold off

n_fig=n_fig+1
figure(n_fig);
plot(XAn(pos==0),XBn(pos==0),'r.','MarkerSize',14)
hold on
plot(XAn(pos==1),XBn(pos==1),'g.','MarkerSize',14)
plot(CA(:),CB(:),'kx',...
     'MarkerSize',10,'LineWidth',3) 

legend('Cluster 1','Cluster 2','Final Centroids','start centroids',...
       'Location','NW')
title 'Cluster Assignments and Centroids'
xlabel 'df'
ylabel 'ddr'
hold off

n_fig=n_fig+1
figure(n_fig);
plot(XBn(pos==0),XCn(pos==0),'r.','MarkerSize',14)
hold on
plot(XBn(pos==1),XCn(pos==1),'g.','MarkerSize',14)
plot(CB(:),CC(:),'kx',...
     'MarkerSize',10,'LineWidth',3) 

legend('Cluster 1','Cluster 2','Final Centroids','start centroids',...
       'Location','NW')
title 'Cluster Assignments and Centroids'
xlabel 'ddr'
ylabel 'dMAC'
hold off

n_fig=n_fig+1
figure(n_fig);
plot(XDn(pos==0),XCn(pos==0),'r.','MarkerSize',14)
hold on
plot(XDn(pos==1),XCn(pos==1),'g.','MarkerSize',14)
plot(CD(:),CC(:),'kx',...
     'MarkerSize',10,'LineWidth',3) 

legend('Cluster 1','Cluster 2','Final Centroids','start centroids',...
       'Location','NW')
title 'Cluster Assignments and Centroids'
xlabel 'dl'
ylabel 'dMAC'
hold off

n_fig=n_fig+1;
figure(n_fig);
plot(XEn(pos==0),XAn(pos==0),'r.','MarkerSize',14)
hold on
plot(XEn(pos==1),XAn(pos==1),'g.','MarkerSize',14)
plot(CE(:),CC(:),'kx',...
     'MarkerSize',10,'LineWidth',3) 

legend('Cluster 1','Cluster 2','Final Centroids','start centroids',...
       'Location','NW')
title 'Cluster Assignments and Centroids'
xlabel 'dMPD'
ylabel 'df'
hold off

n_fig=n_fig+1;
figure(n_fig)
scatter3(XDn(pos==0),XBn(pos==0),XCn(pos==0),'r.')
hold on
scatter3(XDn(pos==1),XBn(pos==1),XCn(pos==1),'g.')
scatter3(CD(:),CB(:),CC(:),'ko','LineWidth',1.5)
xlabel 'dl'
ylabel 'ddr'
zlabel 'dMAC'
hold off


%X1 cluster dei possibili modi fisici
%X2 cluster dei modi certamente spuri

X1=[order' f' dr' V'];
X2=[order' f' dr' V'];

X1(pos,:)=[];
pos= pos(:)==0;
X2(pos,:)=[];

n_fig=n_fig+1;
figure(n_fig)
plot(X1(:,2),X1(:,3),'ro')
hold on
plot(X2(:,2),X2(:,3),'kx',...
    'MarkerSize',5,'LineWidth',0.5)
xlabel 'frequency'
ylabel 'damping ratio'
hold off;

n_fig=n_fig+1;
figure(n_fig)
plot(X1(:,2),X1(:,1),'ro')
hold on
plot(X2(:,2),X2(:,1),'kx',...
    'MarkerSize',5,'LineWidth',0.5)
xlabel 'frequency'
ylabel 'order'
hold off;


n_fig=n_fig+1;
figure(n_fig)
scatter3(X1(:,2),X1(:,3),X1(:,1),'ro')
xlabel 'frequency'
ylabel 'damping ratio'
zlabel 'order'

%hierarchical clustering applicato ai possibili modi fisici (X1)
%D matrice dei parametri da cui calcolare la distanza

y=vector_dif5(X1);
Z=linkage(y,'average');

n_fig=n_fig+1;
figure(n_fig)
dendrogram(Z,0)
hold on
set(gca,'xtick',[])
hold off

%scelta threshold e del conseguente numero di cluster (ncls) e applicazione hierarchical clustering
%fino ad ottenere un numero di cluster pari a quello stabilito

dmax=2;
T = cluster(Z,'cutoff',dmax,'Criterion','distance');

n_fig=n_fig+1;
figure(n_fig)
dendrogram(Z,0,'ColorThreshold',dmax)
hold on
set(gca,'xtick',[])
hold off
ncls=max(T);

n_fig=n_fig+1;
figure(n_fig)
silhouette(X1,T,y)

%separazione dei poli in n cluster

for j=1:ncls;
        pos= T(:)==j;
        HC{1,j}=X1(pos,:);
        HC{2,j}=size(X1(pos,:),1);
end


%separazione modi stabili da instabili
modestable=HC;

%--------------------------------------------------------------------------

n_fig=n_fig+1;
figure(n_fig)
A=cell2mat(modestable(1,:)');
nmode=1:size(modestable,2);
color=rand(size(modestable,2),3);
c=[];
for ii=1:size(modestable,2)
    c=[c repmat(color(ii,:),[modestable{2,ii} 1])'];
end
C=c';
S=20;
scatter3(A(:,2),A(:,3),A(:,1),S,C)
xlabel 'frequency'
ylabel 'damping'
zlabel 'order'

for j=1:size(modestable,2)
    modestable{3,j}=mean(modestable{1,j},1);
    modestable{4,j}=abs((modestable{1,j}(:,2)-modestable{3,j}(:,2))./max(modestable{1,j}(:,2),modestable{3,j}(:,2)))+1-(abs(modestable{1,j}(:,4:end)*modestable{3,j}(:,4:end)')).^2./...
            ((vecnorm(modestable{1,j}(:,4:end)').*norm(modestable{3,j}(:,4:end)))').^2;
        modestable{5,j}=sqrt(sum(modestable{4,j}.^2)/(size(modestable{4,j},1)-1));
end

var=cell2mat(modestable(5,:));
rvar=mean(var);
l=0.05;
distmax=icdf('HalfNormal',l,0,rvar);

for j=1:size(modestable,2)
    pos=[];
    pos=modestable{4,j}>distmax;
        modestable{6,j}=modestable{1,j}(pos==0,:);
        modestable{7,j}=size(modestable{6,j},1);
end

%plotta numero di elementi all'interno di ogni cluster
ncls=size(modestable,2);
nHC=[1:ncls];
n=cell2mat(modestable(7,:));

n_fig=n_fig+1;
figure(n_fig)
bar(nHC,sort(n,'descend'))
hold on
xlabel 'cluster'
ylabel 'n poli interni'
hold off

%aggiunta di cluster vuoti
nmax=max(n);
nCempty=round(nmax);
NHC=[1:(ncls+nCempty)];
N=zeros(1,max(NHC));
N(1,1:ncls)=n;

%2-means clustering applicato al numero di elementi all'interno dei cluster
[idxN,CN] = kmeans(N',2,'start',[nmax;0]);

n_fig=n_fig+1;
figure(n_fig)
bar(NHC(idxN==1),sort(N(idxN==1),'descend'),1,'g')   %,'r.','MarkerSize',14)
hold on
bar(NHC(idxN==2),sort(N(idxN==2),'descend'),1,'r')   %,'g.','MarkerSize',14)

legend('Cluster 1','Cluster 2',...
       'Location','NE')
title 'Cluster Assignments'
xlabel 'cluster'
ylabel 'n poli interni'
hold off

%separazione modi stabili da instabili
modestable2=[];
pos= idxN==1;
modestable2=modestable(6,pos);
modestable2(2,:)=modestable(7,pos);

n_fig=n_fig+1;
figure(n_fig)
A=cell2mat(modestable2(1,:)');
nmode=1:size(modestable2,2);
color=rand(size(modestable2,2),3);
c=[];
for ii=1:size(modestable2,2)
    c=[c repmat(color(ii,:),[modestable2{2,ii} 1])'];
end
C=c';
S=20;
scatter3(A(:,2),A(:,3),A(:,1),S,C)
xlabel 'frequency'
ylabel 'damping'
zlabel 'order'

x11=cell2mat(modestable2(1,:)');
y2=vector_dif5(x11);
Z2=linkage(y2,'average');
T2 = cluster(Z2,'cutoff',dmax,'Criterion','distance');
ncls=max(T2);

n_fig=n_fig+1;
figure(n_fig)
silhouette(x11,T2,y2)

freq=[];
for i=1:size(modestable2,2)
freq=[freq mean(modestable2{1,i}(:,2))];
end

freq=sort(freq)

%extract the most representative parameters (f, dr, V) of each cluster
%case n
% 1 select the mean of all the parameters
% 2 select the closest pole to the mean of the damping ratio
% 3 select the closest pole to the mean of all the parameters
% 4 select the closest pole to the mean of eigenvector
n=1
switch n
    case 1
        for i=1:size(modestable2,2)
            modeID{1,i}=mean(modestable2{1,i}(:,2:end));            
        end
    case 2
        for i=1:size(modestable2,2)
            z=mean(modestable2{1,i}(:,3));
            pos=abs(modestable2{1,i}(:,3)-z)==min(abs(modestable2{1,i}(:,3)-z));
            modeID{1,i}=modestable2{1,i}(pos,2:end);
        end
    case 3
        for i=1:size(modestable2,2)
            M=mean(modestable2{1,i}(:,2:end));
            pos=sum(abs(modestable2{1,i}(:,2:end)-M),2)==min(sum(abs(modestable2{1,i}(:,2:end)-M),2));
            modeID{1,i}=modestable2{1,i}(pos,2:end);
        end
    case 4
               for i=1:size(modestable2,2)
            V=mean(modestable2{1,i}(:,4:end));
            pos=sum(abs(modestable2{1,i}(:,4:end)-V),2)==min(sum(abs(modestable2{1,i}(:,4:end)-V),2));
            modeID{1,i}=modestable2{1,i}(pos,2:end);
        end 
end



mm=cell2mat(modeID')
frs=sort(mm(:,1));
modeID1=modeID;
for ai=1:size(modeID,2)
    fs=frs(ai);
    pos=mm(:,1)==fs;
    modeID(1,ai)=modeID1(1,pos);
end
    
results=struct
for i = 1:size(modeID,2)
    mode_n=['mode' num2str(i)];
    results.Session_05.Setup_01.Acquisition_01.(mode_n).f=modeID{1,i}(1)
    results.Session_05.Setup_01.Acquisition_01.(mode_n).dr=modeID{1,i}(2)*100
    results.Session_05.Setup_01.Acquisition_01.(mode_n).V=modeID{1,i}(3:end)'
    results.Session_05.Setup_01.Acquisition_01.(mode_n).Sensor_list=['03A';'06A';'09A';'03B';'06B';'09B';'03C';'06C';'09C';'03D';'06D';'09D';'14A';'12A';'13A';'14C';'15A';'15B']
end

% load target_shape.mat;

% TSh=target_shape;
% 
% MSh=cell2mat(modeID');
% 
% for i=1:size(MSh,1)
%     for j=1:size(TSh,2);
%         MAC_mx(i,j)=(MSh(i,3:end)*TSh(:,j)).^2/(norm(MSh(i,3:end))*norm(TSh(:,j)))^2;
%     end
% end
% 
% figure(20)
% imagesc(MAC_mx);
% colorbar
% 
% for i=1:size(TSh,2)
%     for j=1:size(TSh,2);
%         MAC_corr(i,j)=(TSh(:,i)'*TSh(:,j)).^2/(norm(TSh(:,i))*norm(TSh(:,j)))^2;
%     end
% end
% 
% figure(21)
% imagesc(MAC_corr)
end

        
        