function [threshold]=threshold_V(X,p)

    for j=1:size(X,1)
        df=[];
        dMAC=[];
        order_1=X(j,1);
        order_2=order_1+2;
        pos=X(:,1)==order_2;
        if sum(pos)>0
        X2=X(pos,:);
        for k=1:size(X2,1)
            df(k)=abs((X(j,2)-X2(k,2)));
            dMAC(k)=1-(abs((X(j,4:end)*(X2(k,4:end)'))))^2/(norm(X(j,4:end))^2*norm(X2(k,4:end))^2);
        end
        df_neighbor(j)=min(df);
        dMAC_neighbor(j)=min(dMAC); 
        else
            df_neighbor(j)=NaN;
            dMAC_neighbor(j)=NaN;
        end
    end
    
   % df, dMAC normalization
   dfn=(df_neighbor-min(df_neighbor))./(max(df_neighbor)-min(df_neighbor));
   dMACn=(dMAC_neighbor-min(dMAC_neighbor))./(max(dMAC_neighbor)-min(dMAC_neighbor));
   
   Y=dfn+dMACn+realmin;
   Y=rmmissing(Y);
   
   %distribution of distance Y
   
   pd=fitdist(Y','Weibull');
   
   a=pd.A;
   b=pd.B;
   
   %calculate the threshold
    [threshold]=icdf('Weibull',p,a,b);
   
end